Code

add -i, send-email, svn, p4, etc: use "git var GIT_EDITOR"
[git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 git_broken_path_fix () {
15         case ":$PATH:" in
16         *:$1:*) : ok ;;
17         *)
18                 PATH=$(
19                         SANE_TOOL_PATH="$1"
20                         IFS=: path= sep=
21                         set x $PATH
22                         shift
23                         for elem
24                         do
25                                 case "$SANE_TOOL_PATH:$elem" in
26                                 (?*:/bin | ?*:/usr/bin)
27                                         path="$path$sep$SANE_TOOL_PATH"
28                                         sep=:
29                                         SANE_TOOL_PATH=
30                                 esac
31                                 path="$path$sep$elem"
32                                 sep=:
33                         done
34                         echo "$path"
35                 )
36                 ;;
37         esac
38 }
40 # @@BROKEN_PATH_FIX@@
42 die() {
43         echo >&2 "$@"
44         exit 1
45 }
47 GIT_QUIET=
49 say () {
50         if test -z "$GIT_QUIET"
51         then
52                 printf '%s\n' "$*"
53         fi
54 }
56 if test -n "$OPTIONS_SPEC"; then
57         usage() {
58                 "$0" -h
59                 exit 1
60         }
62         parseopt_extra=
63         [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64                 parseopt_extra="--keep-dashdash"
66         eval "$(
67                 echo "$OPTIONS_SPEC" |
68                         git rev-parse --parseopt $parseopt_extra -- "$@" ||
69                 echo exit $?
70         )"
71 else
72         dashless=$(basename "$0" | sed -e 's/-/ /')
73         usage() {
74                 die "Usage: $dashless $USAGE"
75         }
77         if [ -z "$LONG_USAGE" ]
78         then
79                 LONG_USAGE="Usage: $dashless $USAGE"
80         else
81                 LONG_USAGE="Usage: $dashless $USAGE
83 $LONG_USAGE"
84         fi
86         case "$1" in
87                 -h|--h|--he|--hel|--help)
88                 echo "$LONG_USAGE"
89                 exit
90         esac
91 fi
93 set_reflog_action() {
94         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95         then
96                 GIT_REFLOG_ACTION="$*"
97                 export GIT_REFLOG_ACTION
98         fi
99 }
101 git_editor() {
102         if test -z "${GIT_EDITOR:+set}"
103         then
104                 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
105         fi
107         eval "$GIT_EDITOR" '"$@"'
110 is_bare_repository () {
111         git rev-parse --is-bare-repository
114 cd_to_toplevel () {
115         cdup=$(git rev-parse --show-cdup)
116         if test ! -z "$cdup"
117         then
118                 # The "-P" option says to follow "physical" directory
119                 # structure instead of following symbolic links.  When cdup is
120                 # "../", this means following the ".." entry in the current
121                 # directory instead textually removing a symlink path element
122                 # from the PWD shell variable.  The "-P" behavior is more
123                 # consistent with the C-style chdir used by most of Git.
124                 cd -P "$cdup" || {
125                         echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
126                         exit 1
127                 }
128         fi
131 require_work_tree () {
132         test $(git rev-parse --is-inside-work-tree) = true ||
133         die "fatal: $0 cannot be used without a working tree."
136 get_author_ident_from_commit () {
137         pick_author_script='
138         /^author /{
139                 s/'\''/'\''\\'\'\''/g
140                 h
141                 s/^author \([^<]*\) <[^>]*> .*$/\1/
142                 s/'\''/'\''\'\'\''/g
143                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
145                 g
146                 s/^author [^<]* <\([^>]*\)> .*$/\1/
147                 s/'\''/'\''\'\'\''/g
148                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
150                 g
151                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
152                 s/'\''/'\''\'\'\''/g
153                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
155                 q
156         }
157         '
158         encoding=$(git config i18n.commitencoding || echo UTF-8)
159         git show -s --pretty=raw --encoding="$encoding" "$1" -- |
160         LANG=C LC_ALL=C sed -ne "$pick_author_script"
163 # Make sure we are in a valid repository of a vintage we understand,
164 # if we require to be in a git repository.
165 if test -z "$NONGIT_OK"
166 then
167         GIT_DIR=$(git rev-parse --git-dir) || exit
168         if [ -z "$SUBDIRECTORY_OK" ]
169         then
170                 test -z "$(git rev-parse --show-cdup)" || {
171                         exit=$?
172                         echo >&2 "You need to run this command from the toplevel of the working tree."
173                         exit $exit
174                 }
175         fi
176         test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
177                 echo >&2 "Unable to determine absolute path of git directory"
178                 exit 1
179         }
180         : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
181 fi
183 # Fix some commands on Windows
184 case $(uname -s) in
185 *MINGW*)
186         # Windows has its own (incompatible) sort and find
187         sort () {
188                 /usr/bin/sort "$@"
189         }
190         find () {
191                 /usr/bin/find "$@"
192         }
193         ;;
194 esac